//////////////////////////////////////////////////////////////////////////
//
//    Program   : log2ps
//
//    File      : icons.cpp
//
//    Copyright (c) 1998 Ottar Kvindesland
//              This file is a part of the source code of log2ps. It may
//              freely be altered. This copyright notice must however not
//              be removed or changed. The source code may only be
//              distributed further if it is done free of charge, and any
//              changes has been authorized by Ottar Kvindesland
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "struct.h"
#include "l2p_com.h"
#include "l2p_glob.h"
#include "o_str.h"
#include "o_files.h"

FILE *iFile;
char iconFile[25] = "LOG2PS.ICS";

//////////////////////////////////////////////////////////////////////////
//
//	setIcons
//
//////////////////////////////////////////////////////////////////////////

void setIcons(void)
{
FILE *fp;

	if (!file_exist(iconFile))
	{	fp = fopen(iconFile, "w+");
		fprintf(fp, "; \n");
		fprintf(fp, ";                      LOG2PS\n");
		fprintf(fp, "; \n");
		fprintf(fp, "; Definition of image icons to be placed on your QSL card.\n");
		fprintf(fp, "; All definitions must be in the EPS format. If you have not yet\n");
		fprintf(fp, "; read the manual, this is the last chance before you may totally\n");
		fprintf(fp, "; ruin your cards. Good luck!\n");
		fprintf(fp, "; \n");
		fprintf(fp, "; File name          X    Y    Scale   Valid (Y/N) \n");
		fprintf(fp, "; ---------------------------------------------------\n");
		fclose (fp);
	};
	system ("edit LOG2PS.ICS");

};	/* setIcons */


//////////////////////////////////////////////////////////////////////////
//
//	nextIconFile
//
//////////////////////////////////////////////////////////////////////////

bool nextIconFile(char *name, int *x, int *y, float *s, int iconNo)
{
FILE *fp;
bool done;
char *fileDef;	// Sorry,cannot avoid pointer. Arrays destroys parameters
char s1[25] = "\0";
int  n = 0;
//int currentIcon = 0;

	fileDef  = (char *) malloc ((sizeof (char) * MAXLINE));

//	currentIcon = 0;
	fp = fopen(iconFile, "r");

	if (file_exist(iconFile));
		fseek(fp, 0, SEEK_SET);

	while ((!feof(fp)) && (n <= iconNo))
	{	strcpy(name, "\0");
		strcpy(fileDef, "\0");
		*x = 0; *y = 0; *s = 0;

		fgets(fileDef, MAXLINE, fp);
		done = (feof(fp));

		if ((!feof(fp)) && (fileDef[0] != ';'))
		{	getGroup (fileDef, name, 1);
			getGroup (fileDef, s1, 2);
			*x = atoi(s1);	strcpy(s1, "\0");
			getGroup (fileDef, s1, 3);
			*y = atoi(s1);	strcpy(s1, "\0");
			getGroup (fileDef, s1, 4);
			*s = atof(s1);
			strcpy(s1, "\0");

			if (strlen(name) > 3)
				n++;
		};
	};

	fclose (fp);
	free (fileDef);
	return (done);

};	/* nextIconFile */