//////////////////////////////////////////////////////////////////////////
//
//    Program   : log2ps
//
//    File      : man.cpp
//
//    Copyright (c) 1998 Ottar Kvindesland
//              This file is a part of the source code of log2ps. It may
//              freely be altered. This copyright notice must however not
//              be removed or changed. The source code may only be
//              distributed further if it is done free of charge, and any
//              changes has been authorized by Ottar Kvindesland
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>

#include "struct.h"
#include "o_str.h"
#include "l2p_glob.h"

FILE *manFile;

int lineNo = 0;
int dest;
char ch = 'a';

//////////////////////////////////////////////////////////////////////////
//
//        lo
//
//////////////////////////////////////////////////////////////////////////
void lo(char *l)
{
	if ((dest == 0) && (ch != 'Q'))
	{
		puts(l);
		if (lineNo++ > 20)
		{
			printf("\n..........Press Q to quit, any key to continue");
			ch = toupper(getche());
			lineNo = 0;
		};
	};
	if (dest == 1)
	{
		fprintf(manFile, "%s", l);
		fprintf(manFile, "\n");
	};

};	/* lo */
//////////////////////////////////////////////////////////////////////////
//
//        ao
//
//////////////////////////////////////////////////////////////////////////
void ao(char *l)
{
	if (!cfg.expert.b)
		lo(l);

};	/* ao */

//////////////////////////////////////////////////////////////////////////
//
//	getWords
//
//	Returns as parameter words to fill a line,
//	and as function index to last word carried out.
//
//////////////////////////////////////////////////////////////////////////
int getWords(char *fullString, int cursor, int lineLen, char *out)
{
char *sp;
char *pout;
int lastWord;
int stringLen;
int n = 0;

	stringLen = strlen(fullString);
	sp = fullString;
	pout = out;

	do
	{	lastWord = n;
		while (*sp++ != ' ')
			n++;
	} while ((n < lineLen) && (n < stringLen));

	sp = fullString;
	for (n = 0; n < cursor; n++)
		sp++;

	for (n = cursor; n < lastWord; n++)
		(*pout++ = *sp++);

	return (lastWord);

};	/* getWords */

//////////////////////////////////////////////////////////////////////////
//
//	wh
//
//	Writes and formats help info.
//
//	Params: c: command, p: parameter; h: help text
//
//////////////////////////////////////////////////////////////////////////
void wh(char *c, char *p, char *h)
{
int tl = 0;
int hd;
int i;
int maxLine;
int n = 0;
char lp[50] = "\0";
char outLine[280] = "\0";
char s1[83] = "\0";
char *nextLine;

	// Setting standard param values - just for simplicity of
	// future coders
	strcpy(lp, p);
	if (strcmp(p, "t") == 0)
		strcpy(lp, "<text string>");
	if (strcmp(p, "i") == 0)
		strcpy(lp, "<integer value>");
	if (strcmp(p, "r") == 0)
		strcpy(lp, "<real value>");
	if (strcmp(p, "0") == 0)
		strcpy(lp, "'0'");
	if (strcmp(p, "1") == 0)
		strcpy(lp, "'1'");

	strcpy(outLine, c);
	tl = 12;
	while (tl > strlen (outLine))
		strcat(outLine, " ");

	strcat(outLine, lp);
	tl = 28;
	while (tl > strlen (outLine))
		strcat(outLine, " ");

	maxLine = 79 - tl;
	n = maxLine;
	if (strlen(h) > maxLine)
	{	while (h[n--] != ' ');
		subStr(h, s1, 0, n);
		strcat(outLine, s1);
		lo(outLine);

		while (n <= strlen(h))
		{	strcpy(outLine, "\0");
			i = 0;
			hd = n;
			n = hd + maxLine;
			while (h[n--] != ' ');
			while (s1[i] != '\0')	// C again, must delete string
				s1[i++] = '\0'; // otherwise fn call no good
			subStr(h, s1, ++hd, n);
			for (tl = 0; tl < 27; tl++)
				strcat (outLine, " ");
			strcat(outLine, s1);
			lo(outLine);

		};
	}	else
	{	strcat(outLine, h);
		lo(outLine);
	};

};	/* wh */

void man_display(void)
{
wh("","","");
wh("Switch", "Parameter", "Action");
wh("-------------------------------------------------------------------------------", "", "");
wh("-?", "", "This help information This switch is not stored in the configuratuion file.");
wh("-bandfrq", "t", "Sets label of Frequency/Band box. Suggested usage is MHz or Band. Set automatic to MHz for switch -slog=EQF, BAND for switch -slog=K1EA.");
wh("-banner", "t", "Place the string as a vertical banner on the right side of the card.");
wh("-banner", "'0", "No banner.");
wh("-blanks", "i", "Will produce a number of blank cards. Not stored as  a configuration. Max 32768 cards.");
wh("-century", "i", "Century number, usually 19 or 20.");
wh("-corners", "0", "QSL cards will have no edge corners.");
wh("-corners", "1", "QSL cards will have edge corners.");
wh("-country", "t", "Country of operation.");
wh("-dest", "t", "PostScript output file from this program.");
wh("-edge", "0", "No space between cards.");
wh("-edge", "1", "Space between each QSL card.");
wh("-fixmod", "t", "Sets a fixed mode for all QSO's disregarding log. Will not appear on blank cards.");
wh("-fixmod", "0", "Uses mode given in log.");
wh("-fixrpt", "t", "Sets a fixed RST for all QSO's disregarding log. Used for eg K1EA where RST is not present in log. Will not appear on blank cards.");
wh("-fixrpt", "0", "Uses report given in log.");
wh("-frame", "0", "QSL cards will have no edge frame.");
wh("-frame", "1", "QSL cards will have edge frame.");
wh("-greeting", "t", "Last greeting on card, eg. PSE QSL, 73 de Ottar.");
wh("-help", "", "This help information. Not stored as a configuration.");
wh("-icons", "0", "No icons will be placed on card.");
wh("-icons", "1", "Icons defined active in icon file log2ps.icn will be printed on card. This switch is not yet active. Warning: This command has not been completely implemented.");
wh("-logfile", "t", "Name of input file to this program This is the file produced by your log program.");
wh("-logo", "'ARRL'", "Place an ARRL logo on the QSL card. Parameter is case sensitive.");
wh("-logo", "'DARC'", "Place an DARC logo on the QSL card. Parameter is case sensitive.");
wh("-logo", "'NRRL'", "Place an NRRL logo on the QSL card. Parameter is case sensitive.");
wh("-logo", "'RSGB'", "Place an RSGB logo on the QSL card. Parameter is case sensitive.");
wh("-logo", "0", "No logo onto the card.");
wh("-lshade", "<decimal value>", "Shade of logo. 0.0 max, 1.0 min.");
wh("-margin", "i", "Left margin on card. Units in 1/72 inch. Default 18.");
wh("-modlbl", "t", "Mode label, eg MODE or 2-WAY.");
wh("-myaddr", "t", "Your postal address.");
wh("-mybbs", "t", "Your AX.25 packet BBS address. Internet mail address will be reset automatically.");
wh("-mybbs", "0", "No packet BBS address.");
wh("-myloc", "t", "Your QTH locator.");
wh("-mymail", "t", "Your internet mail address. AX.25 packet address will be reset automatically.");
wh("-mymail", "0", "No internet mail address.");
wh("-myname", "t", "Your name.");
wh("-myrig", "t", "Your rig, antennae etc.");
wh("-mysig", "t", "Your signature.");
wh("-oscall", "t", "Operating system command to be executed prior to closedown. E.g. 'copy log.ps lpt1', or 'gs log.ps'.");
wh("-pqth", "t", "Name of the portable QTH from where you have worked.");
wh("-pqth", "0", "No portable QTH.");
wh("-ptitle", "0", "Disable particulars titles like OPR, QTH etc.");
wh("-ptitle", "1", "Enable particulars titles like OPR, QTH etc.");
wh("-setdef", "", "Set default configuration file. Not stored as a configuration.");
wh("-shcfg", "", "Show data on the configuration file. Not stored as a configuration.");
wh("-slog", "LOG-EQF", "Will read from a LOG-EQF 8.56 created log.");
wh("-slog", "CT", "Will read from a CT 6.26 created log (freeware).");
wh("-slog", "K1EA", "Will read from a K1EA CT v. 9.10 created log.");
wh("-title", "t", "Title of QSL card. Written above info boxes, e.g I have the pleasure of confirming the QSO:");
wh("-qpday", "t", "Setting positions of substring from log. Day, must be integer 1..31. See Definining log2ps Input.");
wh("-qpfrq", "t", "Setting positions of substring from log. Station.");
wh("-qphdr", "t", "Setting positions of substring from log. Hour.");
wh("-qpmin", "t", "Setting positions of substring from log. Minutes.");
wh("-qpmod", "t", "Setting positions of substring from log.");
wh("-qpmon", "t", "Setting positions of substring from log. Month.");
wh("-qprpt", "t", "Setting positions of substring from log. Station.");
wh("-qptest", "", "Run a test of log with all QPOS... data presented. Not stored as a configuration.");
wh("-qpwrk", "t", "Setting positions of substring from log. Station worked.");
wh("-qpyr", "t", "Setting positions of substring from log. Year, 2 last digits. Century is handled by -century.");
wh("-qsls", "i", "Number of cards on a sheet. Max 4.");
wh("-x", "0", "Not expert, full help info given in help.");
wh("-x", "1", "Expert, only switches described.");
wh("-xchar", "0", "Ordinary english alphabet used.");
wh("-xchar", "1", "Extended alphabet, including Norwegian characters.");
wh("-xoffset", "i", "Adjust the horisontal offset of the cards on the sheet. The integer value represents number of 1/72 inch and may be positive as well as negative.");
wh("-xoffset", "el", "Cards are printed to the left of the sheet.");
wh("-xoffset", "er", "Cards are printed to the right of the sheet.");
wh("-xoffset", "c", "Cards are printed at the center of the sheet.");
wh("-yoffset", "i", "Adjust the vertical offset of the cards on the sheet. The integer value represents number of 1/72 inch and may be positive as well as negative.");
};
//////////////////////////////////////////////////////////////////////////
//
//        man_show
//
//////////////////////////////////////////////////////////////////////////
void man_show(void)
{
lo("LOG2PS (c) 1998 by LA9IHA Ottar Kvindesland");
ao("------------------------- MANUAL LOG2PS --------------------------------");
ao(" ");
ao("This manual has been written to file MAN.DOC");
ao(" ");
ao("The program will read your log file and generate a postscript code for");
ao("individual QSL cards, one for each QSO.");
ao("You may use tho output from one of the following logs:");
ao(" - Log-EQF  : Print out QSO on a one line format to file.");
ao(" - CT       : Print out all QSO's to file");
ao("The postscript output is be directed to file");
ao(" ");
ao("You may invoke the program with the syntax: LOG2PS <switch1>..<switchN>");
ao(" ");
ao("Switches are not case sensitive. They have the syntax:");
ao(" ");
ao("    -<command>=<parameter>.");
ao(" ");
ao("Please note that a switch cannot have any spaces. Where spaces are required");
ao("in the parameter, they should be replaced with underscores _. No switches");
ao("should be longer than 80 characters. All switches will be stored in the");
ao("configuration file unless otherwise instructed in the description below.");
ao("The program will be aborted on detecting illegal switches. Users may");
ao("manipulate the configuration file at their own risk. No percautions is");
ao("taken to validate the data of this file.");
ao(" ");
ao("If the configuration file is detected you may execute the program with");
ao("the parameters present by typing:");
ao(" ");
ao("   log2ps");
ao(" ");
ao("Examples of switches:");
ao(" ");
ao("log2ps -blanks=1                           :Creates a sheet with blank QSL");
ao("                                            cards");
ao("log2ps -logfile=log.txt                    :Sets log2ps to read log from the");
ao("                                            file log.txt");
ao("log2ps -mysig=LA9IHA                       :Defines local signature to");
ao("					    LA9IHA");
ao("log2ps -myaddr=Belsjoevn_5,_N-1440_Droebak :Sets local address to");
ao("					    Belsjoevn 5, N-1440 Droebak");
ao("log2ps -qsls=2 -qslpos=c -century=20       :Sets program to output 2 cards");
ao("					    per sheet, centered and years");
ao("					    will be printed in the range");
ao("					    2000..2099");
ao(" ");
ao(" ");
ao(" ");
ao("HOW TO CREATE QSL CARDS BASED ON LOG FROM LOG-EQF");
ao("-------------------------------------------------");
ao(" ");
ao("Enter Main menu");
ao(" -Setup, Press F2 until 'Printer type to DISK FILE");
ao(" -PRINT Logbook record to DISK FILE");
ao("     -Enter disk file name, eg. log.txt");
ao("     -Logbook print: Select QSO's to output");
ao("     -Select Format: SINGLE LINE");
ao("     -Enter text to print at top of pages: Not necessary");
ao(" -EXIT");
ao(" ");
ao(" ");
ao("The following switches are valid:");
ao(" ");
man_display();

lo(" ");
lo("Please read copyright note at the header of postscript code. If you would");
lo("like to contribute with postscripts please contact me.");
lo(" ");
ao("DISTRIBUTION");
ao("------------------------------------------------------------------------");
ao("You may distribute this program freely by copying the file log2ps.exe");
ao("to your friend. Any other file generated by this program must not be");
ao("distributed. They are your own data.");
ao(" ");
ao("This is a BETA version, please report bugs to me, either by the internet,");
ao("or by post, if you want reply from me, please include a SAE and funds");
ao("for the postage.");
ao("Comments and suggestions are welcome to me at : Ottar Kvindesland");
ao("                                                     Belsjoevn. 5");
ao("                                                   N-1440 Droebak");
ao("                                                           Norway");
ao(" ");
lo("Compiled date                (c) 1996 by LA9IHA Ottar Kvindesland");
lo(compile_date);

};	/* man_show */

//////////////////////////////////////////////////////////////////////////
//
//        man_checkFile
//
//////////////////////////////////////////////////////////////////////////

void man_checkFile(void)
{
	dest = 1;

	manFile = fopen ("man.doc", "r+");
	if (manFile->flags == 0)
	{
		fclose(manFile);
		manFile = fopen ("man.doc", "w");
		man_show();
	};

	fclose(manFile);

};	/* man_checkFile */

//////////////////////////////////////////////////////////////////////////
//
//        man_out
//
//////////////////////////////////////////////////////////////////////////
void man_out(void)
{
	man_checkFile();
	dest = 0;

	man_show();
};

