//////////////////////////////////////////////////////////////////////////
//
//    Program   : log2ps
//
//    File      : ps.cpp
//
//    Copyright (c) 1998 Ottar Kvindesland
//              This file is a part of the source code of log2ps. It may
//              freely be altered. This copyright notice must however not
//              be removed or changed. The source code may only be
//              distributed further if it is done free of charge, and any
//              changes has been authorized by Ottar Kvindesland
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "struct.h"
#include "l2p_glob.h"
#include "icons.h"

FILE *p_psFile;

int qsls=0;

//////////////////////////////////////////////////////////////////////////
//
//      noOfQSLs
//
//	returns number of QSL cards printed
//////////////////////////////////////////////////////////////////////////
int noOfQSLs(void)
{
	return(qsls);

};	/* noOfQSLs */

//////////////////////////////////////////////////////////////////////////
//
//        PS_out_sum
//
//////////////////////////////////////////////////////////////////////////
void PS_sum_out(char *a, char *b)
{
int s1;
char s[6];

	s1 = atoi(a) + atoi(b);
	itoa (s1, s, 10);

	fprintf(p_psFile, "%s", s);

};	/* PS_sum_out */

//////////////////////////////////////////////////////////////////////////
//
//        sPS
//
//////////////////////////////////////////////////////////////////////////
void sPS(char *l)
{
	fprintf(p_psFile, "%s", l);

};	/* sPS */

//////////////////////////////////////////////////////////////////////////
//
//        oPS
//
//////////////////////////////////////////////////////////////////////////
void oPS(char *l)
{
	fprintf(p_psFile, "%s", l);
	fprintf(p_psFile, "\n");

};	/* oPS */

//////////////////////////////////////////////////////////////////////////
//
//        PS_outCard
//
//////////////////////////////////////////////////////////////////////////
void PS_outCard(char *l)
{
	oPS(l);

};	/* PS_outCard */

//////////////////////////////////////////////////////////////////////////
//
//	readEPS
//
//////////////////////////////////////////////////////////////////////////

bool readEps(char *fileName)
{
FILE *efp;
char ch;

	if ((efp = fopen(fileName, "rb")) == NULL)
	{	printf("File %s not available", fileName);
		return (false);
	};


	while (!feof(efp))
	{	ch = fgetc(efp);
		if (ch != '\r')
			fputc(ch, p_psFile);
	};

	fclose (efp);
	return (true);

};	/* readEPS */


//////////////////////////////////////////////////////////////////////////
//
//        is_0
//
//////////////////////////////////////////////////////////////////////////
void printIcons(void)
{
bool iconFileEnd = false;
bool OK = true;

int x, y;
float scale;
int n = 1;
int m;
FILE iconsOverview;
char pl[MAXLINE]      = "\0";
char s1[10]           = "\0";
char *iconFileName;	// Sorry,cannot avoid pointer. Arrays destroys parameters

	iconFileName = (char *) malloc ((sizeof (char) * 25));

	while ((!iconFileEnd) && (OK))
	{
		strcpy(iconFileName, "\0");
		iconFileEnd = nextIconFile(iconFileName, &x, &y, &scale, n++);

		strcpy(pl, "BeginEPSF ");
		itoa(x, s1, 10);
		strcat(pl, s1);
		strcat(pl, " ");
		itoa(y, s1, 10);
		strcat(pl, s1);
		strcat(pl, " translate ");
		itoa(scale, s1, 10);
		strcat(pl, s1);
		strcat(pl, " dup scale ");
		strcat(pl, iconFileName);
		oPS(pl);
//		OK = readEps(iconFileName);
		oPS("EndEPSF");
		for (m=0; m<strlen(iconFileName);m++)
			iconFileName[m] = '\0';
	};
	free(iconFileName);

};	/* printIcons */

//////////////////////////////////////////////////////////////////////////
//
//        is_0
//
//////////////////////////////////////////////////////////////////////////
bool is_0(char *l)
{
bool r;

	r = false;

	if (strlen(l) == 1)
	  if (*l == '0')
	    r = true;

	return (r);

};	/* is_0 */

//////////////////////////////////////////////////////////////////////////
//
//        prt_my
//
//////////////////////////////////////////////////////////////////////////
void prt_my(char *my)
{
char l[MAXLINE] = "\0";

	*l = 0;

	strcpy(l, "(");
	strcat(l, my);
	strcat(l, ")");
	oPS (l);
//	free(l);

};	/* prt_my */

//////////////////////////////////////////////////////////////////////////
//
//        prt_ISOvec
//
//////////////////////////////////////////////////////////////////////////
void prt_ISOvec(void)
{
oPS("/ISOvec [");
oPS("16#0/grave 16#1/acute 16#2/circumflex 16#3/tilde 16#4/macron 16#5/breve");
oPS("16#6/dotaccent 16#7/dieresis 16#8/ring 16#9/cedilla 16#A/hungarumlaut");
oPS("16#B/ogonek 16#C/caron 16#D/dotlessi 16#27/quotesingle 16#60/grave");
oPS("16#7C/bar 16#82/quotesinglbase 16#83/florin 16#84/quotedblbase 16#85");
oPS("/ellipsis 16#86/dagger 16#87/daggerdbl 16#89/perthousand 16#8A/Scaron");
oPS("16#8B/guilsinglleft 16#8C/OE 16#91/quoteleft 16#92/quoteright 16#93");
oPS("/quotedblleft 16#94/quotedblright 16#95/bullet 16#96/endash 16#97");
oPS("/emdash 16#99/trademark 16#9A/scaron 16#9B/guilsinglright 16#9C/oe");
oPS("16#9F/Ydieresis 16#A0/space 16#A4/currency 16#A6/brokenbar 16#A7/section");
oPS("16#A8/dieresis 16#A9/Eth 16#AA/Scaron 16#AB/T");
oPS("16#AC/Zcaron 16#AD/hyphen 16#AE/registered 16#AF/Nj 16#B0/degree");
oPS("16#B1/plusminus 16#B2/twosuperior 16#B3/threesuperior 16#B4/acute 16#B5");
oPS("/mu 16#B6/paragraph 16#B7/periodcentered 16#B8/cedilla 16#B9/eth");
oPS("16#BA/scaron 16#BB/t 16#BC/zcaron 16#BD/onehalf");
oPS("16#BE/threequarters 16#BF/nj 16#C0/Agrave 16#C1/Aacute 16#C2");
oPS("/Acircumflex 16#C3/Atilde 16#C4/Adieresis 16#C5/Aring 16#C6/AE 16#C7");
oPS("/Ccedilla 16#C8/Ccaron 16#C9/Eacute 16#CA/Ecircumflex 16#CB/Edieresis");
oPS("16#CC/Igrave 16#CD/Iacute 16#CE/Icircumflex 16#CF/Idieresis 16#D0/Eth");
oPS("16#D1/Ntilde 16#D2/Ograve 16#D3/Oacute 16#D4/Ocircumflex 16#D5/Otilde");
oPS("16#D6/Odieresis 16#D7/multiply 16#D8/Oslash 16#D9/Ugrave 16#DA/Uacute");
oPS("16#DB/Ucircumflex 16#DC/Udieresis 16#DD/Yacute 16#DE/Thorn 16#DF/germandbls");
oPS("16#E0/agrave 16#E1/aacute 16#E2/acircumflex 16#E3/atilde 16#E4/adieresis");
oPS("16#E5/aring 16#E6/ae 16#E7/ccedilla 16#E8/ccaron 16#E9/eacute 16#EA");
oPS("/ecircumflex 16#EB/edieresis 16#EC/igrave 16#ED/iacute 16#EE/icircumflex");
oPS("16#EF/idieresis 16#F0/eth 16#F1/ntilde 16#F2/ograve 16#F3/oacute 16#F4");
oPS("/ocircumflex 16#F5/otilde 16#F6/odieresis 16#F7/divide 16#F8/oslash");
oPS("16#F9/ugrave 16#FA/uacute 16#FB/ucircumflex 16#FC/udieresis 16#FD/yacute");
oPS("16#FE/thorn 16#FF/ydieresis ] def");
};	/* prt_ISOvec */

//////////////////////////////////////////////////////////////////////////
//
//        prt_fonts
//
//////////////////////////////////////////////////////////////////////////
void prt_fonts(void)
{
if (!cfg.xchar.b)
{
oPS("/font_mysig {/Helvetica-Bold findfont 40 scalefont setfont} def");
oPS("/font_tosig {/Helvetica findfont 20 scalefont setfont} def");
oPS("/font_QSOinfoheader {/Helvetica findfont 5 scalefont setfont} def");
oPS("/font_QSOinfo {/Courier findfont 10 scalefont setfont} def");
oPS("/font_info {/Helvetica findfont 9 scalefont setfont} def");
oPS("/font_infoBold {/Helvetica-Bold findfont 9 scalefont setfont} def");
} else
{
oPS("/font_mysig {/Helvetica-Bold /ISO ISOvec ReEnc /ISO findfont 40");
oPS("scalefont setfont} def");
oPS("/font_tosig {/Helvetica /ISO ISOvec ReEnc /ISO findfont 20 scalefont");
oPS("setfont} def");
oPS("/font_QSOinfoheader {/Helvetica /ISO ISOvec ReEnc /ISO findfont 5 scalefont");
oPS("setfont} def");
oPS("/font_QSOinfo {/Courier /ISO ISOvec ReEnc /ISO findfont 10 scalefont");
oPS("setfont} def");
oPS("/font_info {/Helvetica /ISO ISOvec ReEnc /ISO findfont");
oPS("9 scalefont setfont} def");
oPS("/font_infoBold {/Helvetica-Bold /ISO ISOvec ReEnc /ISO findfont 9");
oPS("scalefont setfont} def");
};
};	/* prt_fonts */

//////////////////////////////////////////////////////////////////////////
//
//        card_pos
//
//////////////////////////////////////////////////////////////////////////
void card_pos(int q)

{
	switch (q)
	{ case 1 : {sPS("/posCard1 {90 rotate ");
		    PS_sum_out(cfg.y_offset.s, "421");
		    sPS(" ");
		    PS_sum_out(cfg.x_offset.s, "-432");
		    oPS(" translate} def");
		   }; break;

	  case 2 : {sPS("/posCard1 {90 rotate ");
		    PS_sum_out(cfg.y_offset.s, "421");
		    sPS(" ");
		    PS_sum_out(cfg.x_offset.s, "-432");
		    oPS(" translate} def");
		    sPS("/posCard2 {w_bigbox -1 mul");
		    if (cfg.edge.b)
			    sPS(" y_ref sub 0 ");
		    else
			    sPS(" 0 ");

		    oPS("translate} def");
		   }; break;

	  case 3 : {sPS("/posCard1 {");
		    PS_sum_out(cfg.y_offset.s, "43");
		    sPS(" ");
		    PS_sum_out(cfg.x_offset.s, "59");
		    oPS(" translate} def");
		    sPS("/posCard2 {0 h_bigbox ");
		    if (cfg.edge.b)
			    sPS("y_ref add ");
		    oPS("translate} def");
		    oPS("/posCard3 {posCard2} def");
		   }; break;

	  case 4 : {sPS("/posCard1 {90 rotate ");
		    PS_sum_out(cfg.y_offset.s, "27");
		    sPS(" h_bigbox y_ref 2 mul add -1 mul ");
		    PS_sum_out(cfg.x_offset.s, "-20");
		    oPS(" add translate} def");

		    sPS("/posCard2 {w_bigbox ");
		    if (cfg.edge.b)
			    sPS("x_ref add ");
		    oPS("0 translate} def");

		    sPS("/posCard3 {0 h_bigbox ");
		    if (cfg.edge.b)
			    sPS("y_ref add ");
		    oPS("-1 mul translate} def");

		    sPS("/posCard4 {w_bigbox ");
		    if (cfg.edge.b)
			    sPS("x_ref add ");
		    oPS("-1 mul 0 translate} def");

		   }; break;
	};

};	/* card_pos */

//////////////////////////////////////////////////////////////////////////
//
//        PS_ARRL_logo
//
//////////////////////////////////////////////////////////////////////////
void PS_ARRL_logo(void)
{
oPS("% ARRL Diamond Logo in native PostScript code");
oPS("% Written by David W. Bray, K2LMG, Clarkson University");
oPS("%   E-mail bray@sun.soe.clarkson.edu");
oPS("%****************************************************");
oPS("% ' The ARRL logo(s) should not be used for *commercial* use");
oPS("%   without permission.  You can use it on club newsletters, QSLs etc");
oPS("%   without explicit permission.  And ARRL membership is not required.'");
oPS("%     Jon Bloom, KE3Z  American Radio Relay League");
oPS("%     Usenet Message-ID: <423@ultrix.uhasun.hartford.edu>");
oPS("% Also slightly adapted to log2ps by LA9IHA");
oPS("%****************************************************");
oPS("/one_coil");
oPS("{ 0 50 moveto");
oPS("  0 0 50 90 270 arc");
oPS("  1 0.3333333 scale");
oPS("  0 -100 50 270 90 arc");
oPS("  1 3 scale } def");
oPS("/inductor");
oPS("{ one_coil");
oPS("  0 -66.6666 translate");
oPS("  one_coil");
oPS("  0 -66.6666 translate");
oPS("  one_coil");
oPS("  0 -66.6666 translate");
oPS("  0 50 moveto");
oPS("  0 0 50 90 270 arc } def");
oPS("/antenna");
oPS("{ -72 255 moveto  72 255 lineto");
oPS("    0 155 lineto -72 255 lineto");
oPS("    0 255 moveto  0 50 lineto } def");
oPS("/ground");
oPS("{ 0 -250 moveto 0 -310 lineto");
oPS("  -72 -310 moveto 72 -310 lineto");
oPS("  -55 -330 moveto 55 -330 lineto");
oPS("  -38 -350 moveto 38 -350 lineto");
oPS("  -21 -370 moveto 21 -370 lineto");
oPS("  -4 -390 moveto 4 -390 lineto } def");
oPS("/diamond");
oPS("{ newpath");
oPS("  -45 10 moveto");
oPS("  0 100 50 0 4 arcto");
oPS("  4 {pop} repeat");
oPS("  50 0 0 -100 10 arcto");
oPS("  4 {pop} repeat");
oPS("  0 -100 -50 0 4 arcto");
oPS("  4 {pop} repeat");
oPS("  -50 0 -45 10 10 arcto");
oPS("  4 {pop} repeat");
oPS(" -45 10 lineto } def");
oPS("/arrl");
oPS("{ gsave");
oPS("  /Helvetica-Bold findfont 30 scalefont setfont");
oPS("  gray_hue setgray");
oPS("  2 setlinewidth");
oPS("  0.85 1.0 scale");
oPS("  diamond		% outside diamond");
oPS("  stroke");
oPS("  0.9 0.9 scale");
oPS("  diamond		% inside diamond");
oPS("  fill			% fill inside diamond to black");
oPS("  1 1 1 setrgbcolor	% set color to white");
oPS(" -11 63 moveto (A) show");
oPS(" -10 -74 moveto (L) show");
oPS(" -41 -10 moveto (R) show");
oPS("  20 -10 moveto (R) show");
oPS("  0 15 translate	% put the antenna, inductor, ground at correct place");
oPS("  0.21 0.16 scale	% get the correct height to width ratio");
oPS("  6 setlinewidth");
oPS("  newpath");
oPS("  antenna");
oPS("  ground");
oPS("  inductor");
oPS("  stroke");
oPS("  grestore } def");
oPS("/soc_logo ");
oPS("{gsave 330 150 translate	% test -- draw near center of page");
oPS("arrl grestore} def		% full size ARRL logo is 2.65 inches tall");
};	/* PS_ARRL_logo */

//////////////////////////////////////////////////////////////////////////
//
//        PS_RSGB_logo
//
//////////////////////////////////////////////////////////////////////////
void PS_RSGB_logo(void)
{
oPS("%");
oPS("% The RSGB 'diamond' logo");
oPS("%");
oPS("% The code below defines a PostScript function 'diamond' which, when");
oPS("% invoked, paints the RSGB diamond at the current x/y.  The resulting");
oPS("% image is 146 points high, in other words a hair over 2 inches.");
oPS("%");
oPS("%	paul koning, 89.01.10 (derived from VERON.PS)");
oPS("%		     89.09.20 - converted to EPSF file");
oPS("% Also slightly adapted to log2ps by LA9IHA");
oPS("%");
oPS("/rsgb");
oPS("{ 0 setlinejoin 2 setlinewidth newpath");
oPS("  gray_hue setgray");
oPS("  1 73 moveto 32 2.5 lineto 63 73 lineto 32 143.5 lineto");
oPS("  closepath stroke				% border for diamond");
oPS("  gsave 8 73 moveto 32 18 lineto 56 73 lineto 32 128 lineto");
oPS("  closepath clip newpath			% clip inside the diamond");
oPS("  20 22.5 moveto 44 22.5 lineto");
oPS("  20 27.5 moveto 44 27.5 lineto");
oPS("  20 32.5 moveto 44 32.5 lineto");
oPS("  20 37.5 moveto 44 37.5 lineto			% ground symbol");
oPS("  32 37.5 moveto 32 65 lineto");
oPS("  0 65 moveto 64 65 lineto");
oPS("  0 81 moveto 64 81 lineto			% capacitor");
oPS("  32 81 moveto 32 125 lineto");
oPS("  17 133 moveto 32 103 lineto 47 133 lineto	% antenna");
oPS("  stroke");
oPS("  grestore					% end clip-in-diamond");
oPS("  /AvantGarde-Demi findfont [15.5 0 0 14 0 0] makefont setfont");
oPS("  10 68 moveto 2.7 0 rmoveto (RSGB) show");
oPS("} def");
oPS("% display the diamond");
oPS("/soc_logo ");
oPS("{gsave 303 63 translate	% test -- draw near center of page");
oPS("rsgb grestore} def		% full size ARRL logo is 2.65 inches tall");
};	/* PS_RSGB_logo */

//////////////////////////////////////////////////////////////////////////
//
//        PS_DARC_logo
//
//////////////////////////////////////////////////////////////////////////
void PS_DARC_logo(void)
{
oPS("%");
oPS("% The DARC 'diamond' logo");
oPS("%");
oPS("% The code below defines a PostScript function 'diamond' which, when");
oPS("% invoked, paints the DARC diamond at the current x/y.  The resulting");
oPS("% image is 146 points high, in other words a hair over 2 inches.");
oPS("%");
oPS("%	paul koning, 89.01.09");
oPS("%                    89.01.10 - fixed a few angles");
oPS("%		     89.08.08 - modified from ARRL to DARC logo");
oPS("%		     89.09.20 - converted to EPSF file");
oPS("% Also slightly adapted to log2ps by LA9IHA");
oPS("%");
oPS("/darc-diamond");
oPS("{  0 setlinejoin 2 setlinewidth newpath");
oPS("  gray_hue setgray");
oPS("  1 73 moveto 32 2.5 lineto 63 73 lineto 32 143.5 lineto");
oPS("  closepath stroke				% border for diamond");
oPS("  2 setlinewidth ");
oPS("  4.5 73 moveto 32 10 lineto 59.5 73 lineto");
oPS("  32 136 lineto closepath fill			% diamond body");
oPS("  1 setgray");
oPS("  29 108 moveto 29 123 lineto 32.5 123 lineto 32.5 119.5 3.5 90 0 arcn");
oPS("  36 111.5 lineto 32.5 111.5 3.5 0 -90 arcn");
oPS("  closepath stroke				% letter D");
oPS("  gsave 0 67 moveto 64 67 lineto 64 90 lineto 0 90 lineto clip newpath");
oPS("  1 setlinejoin");
oPS("  8 60 moveto 17 81 lineto 26 60 lineto");
oPS("  13 71 moveto 21 71 lineto stroke 		% letter A");
oPS("  0 setlinejoin");
oPS("  44 67 moveto 44 82 lineto 48.5 82 lineto 48.5 78.5 3.5 90 -90 arcn");
oPS("  44 75 lineto 48 75 moveto 54 59 lineto stroke	% right letter R");
oPS("  grestore");
oPS("  35.5 27.5 moveto 32 27.5 3.5 0.5 -180 arcn 28.5 35.5 lineto");
oPS("  32 35.5 3.5 180 0 arcn stroke		% letter C");
oPS("  1.5 setlinewidth");
oPS("  31 43 moveto 33 43 lineto");
oPS("  29.375 45.75 moveto 34.625 45.75 lineto");
oPS("  27.75 48.5 moveto 36.25 48.5 lineto");
oPS("  26.125 51.25 moveto 37.875 51.25 lineto");
oPS("  24.5 54 moveto 39.5 54 lineto			% ground symbol");
oPS("  32 54 moveto 32 62 lineto");
oPS("  25 62 25 70 33 70 curveto 39 70 39 66 33 66 curveto");
oPS("  25 66 25 78 33 78 curveto 39 78 39 74 33 74 curveto");
oPS("  25 74 25 86 33 86 curveto 39 86 39 82 33 82 curveto");
oPS("  25 82 25 90 32 90 curveto			% coil");
oPS("  32 102 lineto 25 97 moveto 32 102 lineto");
oPS("  39 97 lineto stroke				% antenna");
oPS("  grestore");
oPS("} def");
oPS("% display the diamond");
oPS("/soc_logo ");
oPS("{gsave 303 63 translate");
oPS("darc-diamond} def");
};	/* PS_DARC_logo */

//////////////////////////////////////////////////////////////////////////
//
//        PS_NRRL_logo
//
//////////////////////////////////////////////////////////////////////////
void PS_NRRL_logo(void)
{
oPS("/start_x 330 def /start_y 250 def /d_dy {100} def /d_dx {d_dy 2 div} def");
oPS("/d_dxm {-1 d_dx mul} def /d_dym {-1 d_dy mul} def /d_start {start_x start_y}");
oPS("def /ros {d_dy 8 div} def /set_line {3 setlinewidth 1 setgray} def");
oPS("/D_c2 {d_dx  d_dym} def /D_c3 {d_dxm d_dym} def /D_c4 {d_dxm d_dy}def");
oPS("/R_c2 {d_dx ros 2 div sub d_dym ros add} def");
oPS("/R_c3 {d_dxm ros 2 div add d_dym ros add} def");
oPS("/R_c4 {d_dxm ros 2 div add d_dy ros sub} def");
oPS("/Rombe_y_centre {start_y d_dy sub} def /Rombe_half_height {d_dy ros sub} def");
oPS("/Lines_space {Rombe_half_height 5 div} def");
oPS("/Ant_Gnd_len {Rombe_half_height 12 mul 25 div} def");
oPS("/Lines_x {start_x d_dx sub Lines_space 2 div add ros 2 div add} def");
oPS("/Line_top_y {Rombe_y_centre Lines_space add} def");
oPS("/Line_bot_y {Rombe_y_centre Lines_space sub} def");
oPS("/Lines_length {d_dx 2 mul ros sub Lines_space sub} def");
oPS("/Ant_top {Ant_Gnd_len Line_top_y add} def");
oPS("/Ant_left {Rombe_half_height 2 mul 23 div} def");
oPS("/Ant_len {Ant_left 2 mul} def /Ant_bot {Ant_len} def");
oPS("/Gnd_depth {Rombe_half_height 3 div} def /Gnd1_y {Line_bot_y Gnd_depth sub} def");
oPS("/Gnd1_left {Rombe_half_height 6 div} def /Gnd1_len {Gnd1_left 2 mul} def");
oPS("/Gnd1_start_x {start_x Gnd1_left sub} def /Gnd_space {Rombe_half_height 12 div} def");
oPS("/Gnd2_y {Gnd1_y Gnd_space sub} def /Gnd2_left {Gnd1_left Gnd_space 2 div sub} def");
oPS("/Gnd2_start_x {start_x Gnd2_left sub} def /Gnd2_len {Gnd1_len Gnd_space sub} def");
oPS("/Gnd3_y {Gnd2_y Gnd_space sub} def /Gnd3_left {Gnd2_left Gnd_space 2 div sub} def");
oPS("/Gnd3_start_x {start_x Gnd3_left sub} def /Gnd3_len {Gnd2_len Gnd_space sub} def");
oPS("/Gnd4_y {Gnd3_y Gnd_space sub} def /Gnd4_left {Gnd3_left Gnd_space 2 div sub} def");
oPS("/Gnd4_start_x {start_x Gnd4_left sub} def /Gnd4_len {Gnd3_len Gnd_space sub} def");
oPS("/L1_s {Lines_x Line_top_y} def /L1_e {Lines_length 0} def");
oPS("/text_x {start_x Rombe_half_height 5 div 2 mul sub} def");
oPS("/text_y {Line_bot_y Lines_space 4 div 2 mul add} def /logo_font");
oPS("{/Helvetica-Bold findfont 25 scalefont setfont 1 setgray} def /Diamond");
oPS("{ newpath  d_start moveto D_c2 rlineto D_c3 rlineto D_c4  rlineto closepath");
oPS("gray_hue setgray fill } def /Rombe { set_line d_start ros sub moveto");
oPS("R_c2 rlineto R_c3 rlineto R_c4 rlineto closepath stroke } def /FrameLines");
oPS("{ set_line Lines_x Line_top_y moveto Lines_length 0 rlineto stroke set_line");
oPS("Lines_x Line_bot_y moveto Lines_length 0 rlineto stroke} def /Antenna { set_line");
oPS("start_x Line_top_y moveto 0 Ant_Gnd_len rlineto stroke set_line start_x Ant_left sub");
oPS("Ant_top moveto Ant_len 0 rlineto Ant_len -2 div Ant_len -1 mul rlineto closepath");
oPS("stroke } def /Ground { set_line start_x Line_bot_y moveto 0 Gnd_depth -1 mul rlineto");
oPS("stroke set_line Gnd1_start_x Gnd1_y moveto Gnd1_len 0 rlineto stroke set_line");
oPS("Gnd2_start_x Gnd2_y moveto Gnd2_len 0 rlineto stroke set_line Gnd3_start_x Gnd3_y moveto");
oPS("Gnd3_len 0 rlineto stroke set_line Gnd4_start_x Gnd4_y moveto Gnd4_len 0 rlineto");
oPS("stroke} def /NRRL_name { text_x text_y moveto logo_font (NRRL) show } def /soc_logo");
oPS("{ Diamond Rombe FrameLines Antenna Ground NRRL_name 0 setgray} def");
};	/* PS_NRRL_logo */

//////////////////////////////////////////////////////////////////////////
//
//        PS_header
//
//////////////////////////////////////////////////////////////////////////
void PS_header(void)
{
char mySig[12];
oPS("%!PS-Adobe-3.0");
oPS("%%Picture: QSL Card");
oPS("%%Creator: LA9IHA Ottar Kvindesland");
sPS("%%Created by log2ps, compilation: ");
oPS(compile_date);
oPS("%============================================================================");
oPS("%");
oPS("% LA9IHA POST SCRIPT QSL CARD");
oPS("%");
oPS("% (c) Ottar Kvindesland 1998");
oPS("%");
oPS("% This postscript code is the sole property of");
oPS("% Ottar Kvindesland. You may freely distribute this code");
oPS("% at whichever price you can get. You may also freely");
oPS("% alter the parameters enclosed by parantheses () unless");
oPS("% otherwise stated, or choose which routines to call.");
oPS("% You may however not remove or change");
oPS("% the phrase 'LA9IHA log2ps' on the visible surface");
oPS("% of the QSL card. If you alter the code of the card, the");
oPS("% modified postscript program may not be redistributed");
oPS("% without the consent of the author. You may not implement this");
oPS("% program as a part of or as output from or as input to other");
oPS("% programs and redistribute theese without the written");
oPS("% permission of the author of this program to make this program");
oPS("% a part of other computer program(s).");
oPS("%");
oPS("% The program is distributed as is, and you may use it");
oPS("% at your own risk. I take no responsibility for any problem");
oPS("% it may cause.");
oPS("%");
oPS("% An updated original code is available at my homepage:");
sPS("%     ");
oPS(log2ps_url);
oPS("%");
oPS("% Postscript is the trademark of Adobe Systems Incorporated.");
oPS("%");
oPS("% I hope you will find the program useful. I would be grateful");
oPS("% for feedback and experiences. If you use it along with");
oPS("% other programs let me hear how it works.");
oPS("% Any comments and suggestions are welcome at:");
sPS("%     ");
oPS(log2ps_mail);
oPS("%");
oPS("% I am available on snail-mail on:");
oPS("% Ottar Kvindesland, Belsjoevn. 5, N-1440 Droebak, Norway.");
oPS("%");
oPS("% If you have not got a postscript printer you may find the program");
oPS("% Ghostscript useful. This is also handy to test out new routines.");
oPS("% Adobe has released a book, The Postscript Tutorial. Recommended.");
oPS("%");
oPS("% 73 de LA9IHA Ottar");
oPS("%============================================================================");
oPS("%");
oPS("% LIST OF DONATORS");
oPS("%");
oPS("% This list contains everyboy out there who has contributed");
oPS("% to this program.");
oPS("%");
oPS("% The grapevine         The ISO vector and the initial definitions.");
if (strcmp(cfg.logo.s, "ARRL") == 0)
	oPS("% KE3Z Jon Bloom        ARRL logo");
if (strcmp(cfg.logo.s, "RSGB") == 0)
	oPS("% Paul Koning           RSGB logo");
if (strcmp(cfg.logo.s, "DARC") == 0)
	oPS("% Paul Koning           DARC logo");
oPS("% LA9IHA Ottar          I made the rest.");
oPS("%");
oPS("%============================================================================");
oPS("/reencsmalldict 12 dict def");
oPS("/ReEnc");
oPS("{ reencsmalldict begin");
oPS("  /newcodesandnames exch def");
oPS("  /newfontname exch def");
oPS("  /basefontname exch def");
oPS("/basefontdict basefontname findfont def");
oPS("/newfont basefontdict maxlength dict def");
oPS("basefontdict");
oPS("{ exch dup /FID ne");
oPS("  { dup /Encoding eq");
oPS("    { exch dup length array copy");
oPS("       newfont 3 1 roll put }");
oPS("    { exch newfont 3 1 roll put }");
oPS("    ifelse");
oPS("  }");
oPS("  { pop pop }");
oPS("  ifelse");
oPS("} forall");
oPS("newfont /FontName newfontname put");
oPS("newcodesandnames aload pop");
oPS("newcodesandnames length 2 idiv");
oPS("  { newfont /Encoding get 3 1 roll put}");
oPS("  repeat");
oPS("  newfontname newfont definefont pop");
oPS("  end");
oPS("} def");
if (cfg.xchar.b)
	prt_ISOvec();
oPS("/p-s {");
oPS("  initmatrix rotate translate");
oPS("  initclip clippath pathbbox newpath");
oPS("  /uy exch def  /rx exch def  /ly exch def  /lx  exch def");
oPS("} def");
oPS("/portrait {0 0 0 p-s /ty 792 def} def");
oPS("/landscape {0 -612 90 p-s /ty 612 def} def");
if (cfg.icons.b)
{
oPS("/BeginEPSF { %def");
oPS("  /b4_Inc_state save def         % Save state for cleanup");
oPS("  /dict_count countdictstack def % Count objects on dict stack");
oPS("  /op_count count 1 sub def      % Count objects on operand stack");
oPS("  userdict begin                 % Push userdict on dict stack");
oPS("  /showpage { } def              % Redefine showpage, { } = null proc");
oPS("  0 setgray 0 setlinecap         % Prepare graphics state");
oPS("  1 setlinewidth 0 setlinejoin");
oPS("  10 setmiterlimit [ ] 0 setdash newpath");
oPS("  /languagelevel where           % If level not equal to 1 then");
oPS("  {pop languagelevel             % set strokeadjust and");
oPS("  1 ne                           % overprint to their defaults.");
oPS("    {false setstrokeadjust false setoverprint");
oPS("    } if");
oPS("  } if");
oPS("} bind def");
oPS("/EndEPSF { %def");
oPS("  count op_count sub {pop} repeat            % Clean up stacks");
oPS("  countdictstack dict_count sub {end} repeat");
oPS("  b4_Inc_state restore");
oPS("} bind def");
};
oPS("/inch {72 mul} def /line_space {10} def /x_ref 18 def /y_ref 18 def");
sPS("/margin {x_ref ");
sPS(cfg.margin.s);
oPS(" add} def /h_bigbox 252 def /w_bigbox 394 def");
oPS("/n_w_bigbox {w_bigbox -1 mul} def /h_littlebox 22 def /w_littlebox 40 def");
oPS("/n_w_littlebox {w_littlebox -1 mul} def /h_qslinfo {108 y_ref add} def");
oPS("/h_greeting {4 h_qslinfo add h_littlebox add} def");
oPS("/w_greeting {margin 36 add} def /h_toRadio {y_ref h_bigbox add 36 sub} def");
oPS("/w_toRadio {margin} def /w_toRadio_sig {margin 0.65 inch add} def");
oPS("/h_bye {18 y_ref add} def /h_stn_1 {80 x_ref add} def");
sPS("/w_stn_info {margin");
if (!cfg.ptitle.b)
	sPS(" ");
else
	sPS(" w_littlebox add");
oPS("} def /h_my_sig {h_bigbox 72 sub} def");
oPS("/w_my_sig w_toRadio_sig def /h_my_loc {h_qslinfo 11 sub} def");
oPS("/w_my_loc {margin 15 add} def /c_len 8 def /nc_len {c_len -1 mul} def");
oPS("/gray_hue { ");
oPS(cfg.lshade.s);
oPS("} def");
oPS("/centre_boxes {w_littlebox 7 mul 2 div margin add} def");
oPS("/print_vertical {gsave -90 rotate show grestore} def");
oPS("/poslittlebox {w_littlebox mul margin add h_qslinfo } def");
oPS("/poslittleboxtext {w_littlebox mul margin add 0.05 inch add");
oPS("  h_qslinfo h_littlebox add 0.1 inch sub moveto} def");
oPS("/poslittleboxdata {w_littlebox mul margin add 0.05 inch add");
oPS(" h_qslinfo 0.05 inch add moveto} def");
card_pos(cfg.cardsPerSheet.i);
if (cfg.frame.b)
{
oPS("/bigbox {x_ref y_ref newpath moveto w_bigbox 0 rlineto 0 h_bigbox");
oPS("rlineto n_w_bigbox 0 rlineto closepath 1 setlinewidth stroke} def");
};
if (cfg.corners.b)
{
oPS("/markcorners {x_ref w_bigbox");
oPS("add c_len sub y_ref newpath moveto c_len 0 rlineto 0 c_len rlineto");
oPS("x_ref w_bigbox add y_ref h_bigbox add c_len sub moveto 0 c_len rlineto");
oPS("nc_len 0 rlineto x_ref c_len add y_ref h_bigbox add moveto nc_len");
oPS("0 rlineto 0 nc_len rlineto x_ref y_ref c_len add moveto 0 nc_len");
oPS("rlineto c_len 0 rlineto 0.1 setlinewidth stroke} def");
};
oPS("/littlebox {newpath moveto w_littlebox 0 rlineto 0 h_littlebox rlineto");
oPS("n_w_littlebox 0 rlineto closepath 0.1 setlinewidth stroke} def");
prt_fonts();
oPS("/year_box {0 poslittleboxtext font_QSOinfoheader (YEAR) show");
oPS("0 poslittleboxdata font_QSOinfo show 0 poslittlebox littlebox} def");
oPS("/month_box {1 poslittleboxtext font_QSOinfoheader (MONTH) show");
oPS("1 poslittleboxdata font_QSOinfo show 1 poslittlebox littlebox} def");
oPS("/day_box {2 poslittleboxtext font_QSOinfoheader (DAY) show");
oPS("2 poslittleboxdata font_QSOinfo show 2 poslittlebox littlebox} def");
oPS("/UTC_box {3 poslittleboxtext font_QSOinfoheader (UTC) show");
oPS("3 poslittleboxdata font_QSOinfo show 3 poslittlebox littlebox} def");
oPS("/MHz_box {4 poslittleboxtext font_QSOinfoheader");
prt_my(cfg.bandFrq.s);
oPS("show 4 poslittleboxdata font_QSOinfo show 4 poslittlebox littlebox} def");
oPS("/mode_box {5 poslittleboxtext font_QSOinfoheader");
prt_my(cfg.modlbl.s);
oPS(" show 5 poslittleboxdata font_QSOinfo show 5 poslittlebox littlebox} def");
oPS("/RST_box {6 poslittleboxtext font_QSOinfoheader (RST) show");
oPS("6 poslittleboxdata font_QSOinfo show 6 poslittlebox littlebox} def");
oPS("/to_radio {w_toRadio_sig h_toRadio moveto font_tosig show} def");
oPS("/print_standard");
oPS("/print_standard {centre_boxes font_info ");
prt_my(cfg.title.s);
oPS("stringwidth pop 2 div sub h_greeting moveto ");
prt_my(cfg.title.s);
oPS("show  w_toRadio h_toRadio moveto (To Radio : ) show");
oPS("  margin 2 inch add h_bye moveto");
prt_my(cfg.greeting.s);
oPS("  show");
if (cfg.ptitle.b)
{	oPS("  font_infoBold margin h_stn_1 moveto (OPR) show");
	oPS("  margin h_stn_1 line_space sub moveto (QTH) show");
	oPS("  margin h_stn_1 line_space 2 mul sub moveto (RIG) show");
	if (cfg.myBBS.b || cfg.myMail.b)
	{	oPS("  margin h_stn_1 line_space 3 mul sub moveto ");
		if (cfg.myBBS.b)
			oPS("(BBS)");
		else
			oPS("(MAIL)");
		oPS(" show");
	};
};
oPS("% Next 3 lines MUST be incorporated in the program (Copyright notice)");
oPS("  w_toRadio h_toRadio 0.3 inch sub moveto");
oPS("  /Helvetica findfont 5 scalefont setfont (LA9IHA log2ps) dup print_vertical");
oPS("} def");
oPS("/print_local {font_info w_stn_info h_stn_1 moveto");
prt_my(cfg.myName.s);
oPS("show w_stn_info h_stn_1 line_space sub moveto");
prt_my(cfg.myAddress.s);
oPS("show w_stn_info h_stn_1 line_space 2 mul sub moveto");
prt_my(cfg.myRig.s);
oPS("show w_stn_info h_stn_1 line_space 3 mul sub moveto");
if (cfg.myBBS.b)
	prt_my(cfg.myBBS.s);
if (cfg.myMail.b && !cfg.myBBS.b)
	prt_my(cfg.myMail.s);
if (cfg.myBBS.b || cfg.myMail.b)
	oPS(" show");

oPS("centre_boxes");
prt_my(cfg.myQTH.s);
oPS("stringwidth pop 2 div sub h_my_loc moveto");
prt_my(cfg.myQTH.s);

strcpy(mySig, cfg.mySig.s);

oPS("show centre_boxes font_mysig");
prt_my(mySig);
oPS("stringwidth pop 2 div sub h_my_sig moveto ");
prt_my(mySig);
oPS("show font_infoBold centre_boxes ");
prt_my(cfg.country.s);
oPS(" stringwidth pop 2 div sub	h_greeting 16 add moveto ");
prt_my(cfg.country.s);
oPS(" show } def");

if (cfg.pQTH.b)
{
  oPS("/print_pqth");
  oPS("{");
  if (cfg.ptitle.b)
    oPS("  font_infoBold margin h_stn_1 line_space 4 mul sub moveto (P/QTH) show");
  oPS("  font_info w_stn_info h_stn_1 line_space 4 mul sub moveto show");
  oPS("} def");
};
if (cfg.banner.b)
{
oPS("/print_v_info {dup font_tosig 8 w_littlebox mul margin add exch");
oPS("stringwidth pop 2 div y_ref h_bigbox add 2 div add moveto");
oPS("print_vertical} def");
};
if (cfg.logo.b)
{	if (strcmp(cfg.logo.s, "NRRL") == 0)
		PS_NRRL_logo();
	if (strcmp(cfg.logo.s, "ARRL") == 0)
		PS_ARRL_logo();
	if (strcmp(cfg.logo.s, "RSGB") == 0)
		PS_RSGB_logo();
	if (strcmp(cfg.logo.s, "DARC") == 0)
		PS_DARC_logo();
};
oPS("/printcard { ");
if (cfg.logo.b)
	oPS(" soc_logo ");
if (cfg.corners.b)
	oPS(" markcorners");
if (cfg.frame.b)
	oPS(" bigbox ");
oPS("  year_box month_box day_box UTC_box MHz_box mode_box RST_box");
oPS("  to_radio");
oPS("  print_standard print_local");
if (cfg.pQTH.b)
{
	prt_my(cfg.pQTH.s);
	oPS(" print_pqth");
};
if (cfg.banner.b)
{
	prt_my(cfg.banner.s);
	oPS(" print_v_info ");
};
if (cfg.icons.b)
	printIcons();
oPS("} def");
oPS("/print1card {printcard showpage} def");

};	/* PS_header */
//////////////////////////////////////////////////////////////////////////
//
//        PS_close
//
//////////////////////////////////////////////////////////////////////////
void PS_close(void)
{
	fclose(p_psFile);

};	/* PS_close */

//////////////////////////////////////////////////////////////////////////
//
//        PS_print_header
//
//////////////////////////////////////////////////////////////////////////
void PS_print_header (void)
{
	p_psFile = fopen(cfg.dest.s, "w");
	if (p_psFile -> flags == 0)
		printf("Creating %s From empty.\n", cfg.dest);
	PS_header();
};
